"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createSetHeadersMiddleware({ dynamicHeaders = {}, staticHeaders = {}, copyFromRequestHeaders = [], } = {}) {
    return (req, res, next) => {
        const copiedFromRequestHeaders = {};
        for (const header of copyFromRequestHeaders) {
            copiedFromRequestHeaders[header] = req.get(header);
        }
        const dynamicResolvedHeaders = {};
        for (const header in dynamicHeaders) {
            if (typeof dynamicHeaders[header] === 'function') {
                dynamicResolvedHeaders[header] = dynamicHeaders[header](req);
            }
        }
        const combinedHeaders = Object.assign({}, staticHeaders, copiedFromRequestHeaders, dynamicResolvedHeaders);
        res.set(combinedHeaders);
        next();
    };
}
exports.default = createSetHeadersMiddleware;
